﻿@using Portal.Models;
@using System.Web.UI.WebControls;
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@model Toyota.Common.Web.MVC.ModelHolder
@{     
    Layout = "~/Views/Layout/Dashboard.cshtml";
}

<style type="text/css">
    #CREATED_DT_FROM, #CREATED_DT_TO, input#CREATED_DT_FROM_I, input#CREATED_DT_TO_I,
    #INVOICE_DT_FROM, #INVOICE_DT_TO, input#INVOICE_DT_FROM_I, input#INVOICE_DT_TO_I
    {
        background-color:#F6cece;
    }
    #PAYMENT_DT_FROM, #PAYMENT_DT_TO, input#PAYMENT_DT_FROM_I, input#PAYMENT_DT_TO_I,
    #LogisticPartnerOption, input#LogisticPartnerOption_I, #StatusOption, input#StatusOption_I,
    #DELIVERY_NO2, input#DELIVERY_NO2_I, #INVOICE_NO, input#INVOICE_NO_I
    {
        background-color:#F5F6ce;
    }
</style>

<script type="text/javascript">
    var parameterList = "";
    var isExecute = false;
    var action = "";

    $(document).ready(function() {
        GridLogisticPartnerOption.SetHeight(-149);
        GridStatusOption.SetHeight(-73);
        gridPopupDetail.SetHeight(180);

        GridLogisticPartnerOption.PerformCallback();

        if (GridDeliveryInvoiceAndPay.GetSelectedRowCount() == 0 && GridDeliveryInvoiceAndPay.cpVisibleRow == 0)
        {
            SelectAllCheckBox.SetValue(false);
        }

        $('#info').hide();

        $('#INVOICE_NO_I').keypress(function(e){
            if(e.keyCode == 8 || e.keyCode == 46 || e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40)
            {

            }else if(String.fromCharCode(e.which).match(/[^A-Za-z0-9]/)){
                e.preventDefault();
            }
        });

        $('#DELIVERY_NO2_I').keypress(function(e){
            if(e.keyCode == 8 || e.keyCode == 46 || e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40)
            {

            }else if(String.fromCharCode(e.which).match(/[^A-Za-z0-9]/)){
                e.preventDefault();
            }
        });

        $('#GridEditLP').attr("style", "heigth:200px");

    });

    function GridDeliveryInvoiceAndPay_Init(s, e) {
        GridDeliveryInvoiceAndPay.PerformCallback();
        enabledButton();
    }

    function OnEndCallbackGrid(s, e)
    {
        enabledButton();

        if (GridDeliveryInvoiceAndPay.GetSelectedRowCount() == 0 && GridDeliveryInvoiceAndPay.cpVisibleRow == 0)
        {
            SelectAllCheckBox.SetValue(false);
        }

        if(isExecute==true)
        {
            //alert (action);
            isExecute = false;
            getKeyField();
        }
    }


    function getKeyField(){
        var counter = 0;
        for (var index = GridDeliveryInvoiceAndPay.cpStartIndex; index < GridDeliveryInvoiceAndPay.cpEndIndex; index++) {
            if(GridDeliveryInvoiceAndPay.cpIsRowSelected[index]==true){
                parameterList += GridDeliveryInvoiceAndPay.cpDATA_KEY[index];
                parameterList += ",";
            }
            counter++;
        }

        setExecute();

        //parameterList = parameterList.substring(0, parameterList.length - 1);
        //setExecute();
        //console.log(parameterList);
       // return parameterList;
    }


    function setExecute()
    {
        parameterList = parameterList.substring(0, parameterList.length - 1);

        //alert(parameterList);

        if (parameterList!=''){

            if (action == "printCertificate"){
                checkStatus(parameterList);
                parameterList = "";
                action = "";
            }
            else if (action == "cancel"){
                //modif by agung 25.06.2014 
                        $.msgBox({
                               type: "confirm",
                               content: "Invoice Number will be cancel, are you sure?",
                               buttons: [{ value: "Yes" }, { value: "No"}],
                               success: function (result) {
                                    if (result == "Yes") {
                                     //alert(parameterList);
                                     performCancel(parameterList);
                                     parameterList = "";
                                     action = "";
                                     }
                                }
                            });
                //end modif

                
            }
            else if (action == "posting"){
                  var selectedKey = GridDeliveryInvoiceAndPay.GetSelectedKeysOnPage();
                  if(selectedKey.length > 1) {
                    $.msgBox({ title: "Error", type: "error", content: "Please select one Invoice Number to posting"});
                    selectedKey = "";
                    //GridDeliveryInvoiceAndPay.UnselectAllRowsOnPage();
                    GridDeliveryInvoiceAndPay.UnselectRows();
                    parameterList = "";
                    action = "";
                    return;
                  }else{
                        VerificationPosting(parameterList);
                  }
                  

            }
            else if (action == "reverse"){
                //modif by agung 25.06.2014 
                        $.msgBox({
                               type: "confirm",
                               content: "Invoice Number will be reverse, are you sure?",
                               buttons: [{ value: "Yes" }, { value: "No"}],
                               success: function (result) {
                                    if (result == "Yes") {
                                        //alert(parameterList);
                                        performReverse(parameterList);
                                        parameterList = "";
                                        action = "";
                                     }
                                }
                            });
                //end modif
            }else{


            }
        }else{

            $.msgBox({ title: "Warning", type: "alert", content: "Please, select one data!", afterClose : enabledButton }); 
            disabledButton();
        
        }
    }

    
    function VerificationPosting(INV_NO){
        //GridPartnerBankOption.UnselectFilteredRows();
        //GridPayMethodOption.UnselectFilteredRows();
        //GridPayTermOption.UnselectFilteredRows();
        //GridTaxOption.UnselectFilteredRows();
        btnPost.SetEnabled(true);
        btnSave.SetEnabled(true);
        var SupplierInvoiceNo ='';
        LP_Option.SetText("");
        LP_INV_NO.SetText("");
        AMOUNT.SetText("");
        INV_DT.SetText("");
        PartnerBankOption.SetText("");
        HEADER_TEXT.SetText("");
        BASELINE_DT.SetText("");
        TaxOption.SetText("");
        PayTermOption.SetText("");
        TAX_DT.SetText("");
        PayMethodOption.SetText("");
        POS_DT.SetText("");
        INV_NOTE.SetText("");
        $.ajax({
                    type: "POST",
                    url: "@Url.Content("~/D31405/GetPostingDetail")",
                    data: {
                        SupplierInvoiceNo: INV_NO
                    },
                    success: function (result) {
                        $.each(result, function (index, item) {
                            if (item) {
                                LP_Option.SetText(item.LP_CD);
                                PartnerBankOption.SetText(item.PARTNER_BANK)
                                LP_INV_NO.SetText(item.INVOICE_NO);
                                AMOUNT.SetText(item.TOTAL_AMOUNT);
                                INV_DT.SetText(item.INVOICE_DATE);
                                HEADER_TEXT.SetText(item.HEADER_TEXT);
                                BASELINE_DT.SetText(item.BASELINE_DATE);
                                TaxOption.SetText(item.TAX_CODE);
                                PayTermOption.SetText(item.TERM_PAYMENT);
                                TAX_DT.SetText(item.TAX_DATE);
                                PayMethodOption.SetText(item.PAYMENT_METHOD);
                                POS_DT.SetText(item.POSTING_DATE);
                                INV_NOTE.SetText(item.INV_NOTES);

                                if(item.STATUS == "Submitted"){
                                     btnPost.SetEnabled(true);
                                     btnSave.SetEnabled(true);
                                }
                                if(item.STATUS == "Reversed"){
                                     btnPost.SetEnabled(true);
                                     btnSave.SetEnabled(true);
                                }
                                if(item.STATUS == "Error Posting"){
                                     btnPost.SetEnabled(true);
                                     btnSave.SetEnabled(true);
                                }
                                else if(item.STATUS == "Posted"){
                                     btnPost.SetEnabled(false);
                                     btnSave.SetEnabled(false);
                                }
                                else if(item.STATUS == "Paid"){
                                     btnPost.SetEnabled(false);
                                     btnSave.SetEnabled(false);
                                }
                                else if(item.STATUS == "Created"){
                                     btnPost.SetEnabled(false);
                                     btnSave.SetEnabled(false);
                                }
                                else if(item.STATUS == "Rejected"){
                                     btnPost.SetEnabled(false);
                                     btnSave.SetEnabled(false);
                                }
                            }
                            popupVerificationInvoice.Show();
                            SupplierInvoiceNo ='';
                            
                        });                                      
                    },
                    error: function (result) {
                        $.msgBox({ title: "Warning", type: "alert", content: "Data not exist", afterClose : enabledButton });
                    }
                });
        parameterList ='';
    }

    function PostingSave_Click(s, e) {
            $.ajax({
                type: "POST",
                url: "@Url.Content("~/D31405/SavePosting")",
                data: {
                    
                        INV_NO : LP_INV_NO.GetText(),
                        PARTNER_BANK : PartnerBankOption.GetText(),
                        BASELINE_DATE : BASELINE_DT.GetText(),
                        TAX_CODE_2 : TaxOption.GetText(),
                        TERM_PAYMENT_2 : PayTermOption.GetText(),
                        PAYMENT_METHOD_2 : PayMethodOption.GetText(),
                        INVOICE_NOTE : INV_NOTE.GetValue()

                    },
                    success: function (result) {
                        var resValue = result.split('|');
                        if (resValue[0] == 'Error')
                        {
                            
                            //MessageBox(resValue[1],'error_icon.png','Error',300);
                            $.msgBox({ title: "Warning", content: resValue[1] , afterClose : enabledButton });
                            popupVerificationInvoice.Hide();
                        }
                        else
                        {
                            //MessageBox(resValue[1],'info_icon.png','Information',270);
                            $.msgBox({ title: "info",type: "info", content: resValue[1] , afterClose : enabledButton });
                            popupVerificationInvoice.Hide();
                        }
                    },
                    error: function (result) {
                        var resValue = result.split('|');
                        //MessageBox(resValue[1],'error_icon.png','Error',300);
                        $.msgBox({ title: "error",type: "error", content: resValue[1] , afterClose : enabledButton });
                        popupVerificationInvoice.Hide();
                    }
                });
     }


    
    function performPosting(s, e){

        $.ajax({
            type: "POST",
            url: "@Url.Content("~/D31405/performPosting")",
            data: {
                    INV_NO : LP_INV_NO.GetText(),
                    PARTNER_BANK : PartnerBankOption.GetText(),
                    POSTING_DATE : POS_DT.GetText(),
                    BASELINE_DATE : BASELINE_DT.GetText(),
                    TAX_CODE_2 : TaxOption.GetText(),
                    TERM_PAYMENT_2 : PayTermOption.GetText(),
                    PAYMENT_METHOD_2 : PayMethodOption.GetText(),
                    INVOICE_NOTE : INV_NOTE.GetValue()
                },
                success: function (result) {
                    var resValue = result.split('|');
                    if (resValue[0] == 'Error')
                    {
                        //MessageBox(resValue[1],'error_icon.png','Error',280);
                        $.msgBox({ title: "error", type: "error", content: resValue[1], afterClose : enabledButton });
                        disabledButton();
                        //clearGrid();
                        popupVerificationInvoice.Hide();
                    }
                    else
                    {
                        //MessageBox(resValue[1],'info_icon.png','Information',330);
                        $.msgBox({ title: "info", type: "info", content: resValue[1], afterClose : enabledButton });
                        disabledButton();
                        //clearGrid()
                        checkProgressPosting();
                        popupVerificationInvoice.Hide();
                    }
                },
                error: function (result) {
                    //MessageBox(resValue[1],'error_icon.png','Error',300);
                    $.msgBox({ title: "error", type: "error", content: resValue[1], afterClose : enabledButton });
                    disabledButton();
                    //clearGrid();
                    popupVerificationInvoice.Hide();
                }
            });

    }

    function GridDeliveryInvoiceAndPay_SelectionChange(s,e) {
        //var length_arr = GridDeliveryInvoiceAndPay.GetSelectedKeysOnPage().length;
        //var count = GridDeliveryInvoiceAndPay.pageRowCount;
        //var count2 = GridDeliveryInvoiceAndPay.GetSelectedRowCount();

        if (GridDeliveryInvoiceAndPay.GetSelectedRowCount() == GridDeliveryInvoiceAndPay.cpVisibleRow){
            SelectAllCheckBox.SetValue(true);
        }
        else
        {
            SelectAllCheckBox.SetValue(false);
        }
        //GridDeliveryInvoiceAndPay.PerformCallback();
        //parameterList = "";
        //counter = 0;



        //s.GetSelectedFieldValues(GridDeliveryInvoiceAndPay.cpKeyField, GetSelectedFieldValuesCallback);
    }

//    function GetSelectedItemsText(items)
//    {
//        var texts = [];
//        var textSeparator = ";";
//        for (var i = 0; i < items.length; i++){
//            if (items[i] != ''){
//                texts.push(items[i].trim());
//            }
//        }

//        txtGridTemp.SetValue(texts.join(textSeparator));
//        //console.log(texts.join(textSeparator));
//    }

//    function GetSelectedFieldValuesCallback(values)
//    {
//        GetSelectedItemsText(values);
//        //console.log(values);
//    }
    
    function convertDate (param){
        var param;
        if (param == null){
            dateVal = null;
        }else{
            var d = new Date(param);
            var curr_date = d.getDate();
            var curr_month = d.getMonth() + 1 ;
            var curr_year = d.getFullYear();
            var n = String(curr_month).length;
                if (n==1){
                    curr_month = '0'+curr_month;
                }else{
                    curr_month= curr_month;
                }
            var d = String(curr_date).length;
                if (n==1){
                    curr_date = '0'+curr_date;
                }else{
                    curr_date= curr_date;
                }
            var dateVal = curr_year+'-'+curr_month+'-'+curr_date;
        }
        return dateVal;
    }

    function convertDate2 (param){
        var param;
        if (param == null){
            dateVal = null;
        }else{
            var d = new Date(param);
            var curr_date = d.getDate();
            var curr_month = d.getMonth() + 1 ;
            var curr_year = d.getFullYear();
            var n = String(curr_month).length;
                if (n==1){
                    curr_month = '0'+curr_month;
                }else{
                    curr_month= curr_month;
                }
            var dateVal = curr_year+'/'+curr_month+'/'+curr_date;
        }
        return dateVal;
    }

    var InvoiceNo = "";
    function OnBeginCallbackGrid(s, e) {
        e.customArgs["LP_CD"] = LogisticPartnerOption.GetValue();
        e.customArgs["CREATED_DT_FROM"] = CREATED_DT_FROM.GetText();
        e.customArgs["CREATED_DT_TO"] = CREATED_DT_TO.GetText();
        e.customArgs["INVOICE_DT_FROM"] = INVOICE_DT_FROM.GetText();
        e.customArgs["INVOICE_DT_TO"] = INVOICE_DT_TO.GetText();
        e.customArgs["PAYMENT_DT_FROM"] = PAYMENT_DT_FROM.GetText();
        e.customArgs["PAYMENT_DT_TO"] = PAYMENT_DT_TO.GetText();
        e.customArgs["StatusOption"] = StatusOption.GetText();
        e.customArgs["DELIVERY_NO"] = DELIVERY_NO2.GetText();
        e.customArgs["INVOICE_NO"] = INVOICE_NO.GetText();

        e.customArgs["visible"] = GridDeliveryInvoiceAndPay.columns[11].visible;

        disabledButton();
    }

    function MessageBox(s, e, headerText, width) {
        if (e != "") {
            msgboxicon.src = '/Content/Images/' + e;
        } else {
            msgboxicon.src = '';
        }
        msgboxcaption.SetText(s);
        msgbox.SetWidth(width);
        msgbox.SetHeaderText(headerText);
        msgbox.Show();
    }


    function SearchData() {
        var result = false;

        if (ValidationSearch()) {
            //if (CREATED_DT_FROM.GetText() != '' && CREATED_DT_TO.GetText() != '') {
                    
                   if (CREATED_DT_FROM.GetValue() > CREATED_DT_TO.GetValue() ){
                        //MessageBox('Created date from should not be greater than created date to', 'warning_icon.png', 'Warning', 290);
                        $.msgBox({ title: "Warning", type: "alert", content: "Created date from should not be greater than created date to", afterClose : enabledButton });
                        disabledButton();
                   }
                   else if (INVOICE_DT_FROM.GetValue() > INVOICE_DT_TO.GetValue() ){
                        //MessageBox('Invoice date from should not be greater than invoice date to', 'warning_icon.png', 'Warning', 290);
                        $.msgBox({ title: "Warning", type: "alert", content: "Invoice date from should not be greater than invoice date to", afterClose : enabledButton }); 
                        disabledButton();
                   }
                   else if (PAYMENT_DT_FROM.GetValue() > PAYMENT_DT_TO.GetValue() )
                   {
                        //MessageBox('Invoice date from should not be greater than invoice date to', 'warning_icon.png', 'Warning', 290);
                        $.msgBox({ title: "Warning", type: "alert", content: "Payment date from should not be greater than payment date to", afterClose : enabledButton }); 
                        disabledButton();
                   }
                   else{
                        GridDeliveryInvoiceAndPay.ClearFilter();
                        GridDeliveryInvoiceAndPay.UnselectAllRowsOnPage();
                   }
        }
    }



        //Download Excel------------------------------------------------------------------------------------------
    var IsDownload = "no";

    function DownloadData(s, e) {
        

        if(ValidationSearch())
//        {
//            //MessageBox('Please, select production month!','warning_icon.png','Warning',290);
//            $.msgBox({ title: "Warning", content: "Please, select production month!" , afterClose : enabledButton });
//            disabledButton();
//        }
//        else
        {
            IsDownload = "yes";   
            BeginCallbackDownload(s, e);
        }

        
    }


    function BeginCallbackDownload(s, e) {
        if (ValidationSearch()){
          $.ajax(
            {
                type: "POST",
                url: "@Url.Content("~/D31405/exportToExcel")",
                data:
                {
                    LP_CD           : LogisticPartnerOption.GetValue(),
                    CREATED_DT_FROM : CREATED_DT_FROM.GetText(),
                    CREATED_DT_TO   : CREATED_DT_TO.GetText(),
                    INVOICE_DT_FROM : INVOICE_DT_FROM.GetText(),
                    INVOICE_DT_TO   : INVOICE_DT_TO.GetText(),
                    PAYMENT_DT_FROM : PAYMENT_DT_FROM.GetText(),
                    PAYMENT_DT_TO   : PAYMENT_DT_TO.GetText(),
                    StatusOption    : StatusOption.GetText(),
                    DELIVERY_NO     : DELIVERY_NO2.GetText(),
                    INVOICE_NO      : INVOICE_NO.GetText(),

                    inv_no          : GridDeliveryInvoiceAndPay_DXFREditorcol1.GetText(),
                    inv_dt          : convertDate (GridDeliveryInvoiceAndPay_DXFREditorcol2.GetValue()),
                    curr            : GridDeliveryInvoiceAndPay_DXFREditorcol3.GetText(),
                    total_amt       : GridDeliveryInvoiceAndPay_DXFREditorcol4.GetText(),
                    amt_before      : GridDeliveryInvoiceAndPay_DXFREditorcol5.GetText(),
                    tax_amt         : GridDeliveryInvoiceAndPay_DXFREditorcol6.GetText(),
                    status          : GridDeliveryInvoiceAndPay_DXFREditorcol7.GetText(),

                    plan            : convertDate2 (GridDeliveryInvoiceAndPay_DXFREditorcol9.GetValue()),
                    actual          : convertDate2 (GridDeliveryInvoiceAndPay_DXFREditorcol10.GetValue()),
                    progress        : GridDeliveryInvoiceAndPay_DXFREditorcol11.GetText(),
                    createdby       : GridDeliveryInvoiceAndPay_DXFREditorcol13.GetText(),
                    createddt       : convertDate2 (GridDeliveryInvoiceAndPay_DXFREditorcol14.GetValue()),
                    
                    //lp_cd2          : GridDeliveryInvoiceAndPay_DXFREditorcol24.GetText(),
                    //lp_name         : GridDeliveryInvoiceAndPay_DXFREditorcol25.GetText()
              },
                success: function (result) {
                    
                    if (result.excelLink == 'Data not found!'){
                        //MessageBox(result.excelLink,'info_icon.png','Information',200);
                        
                        $.msgBox({ title: "info",type: "info", content: result.excelLink , afterClose : enabledButton });
                        
                        disabledButton();
                        
                    }else
                    {
                        var link = "@Url.Content("~/")"+result.excelLink;
                        window.location = link;
                    }

                    
                },
                error: function (result) {
                    //MessageBox('Error when downloading data.','error_icon.png','Error',280);
                    $.msgBox({ title: "error",type: "error", content: "Error when downloading data.", afterClose : enabledButton });
                    disabledButton();
                }
            });
        }
    }
    //---------------------------------------------------------------------------------------------------------


    var IsDownloadDetail = "no";

    function DownloadDetailData(s, e) {
        IsDownloadDetail = "yes";   
        BeginCallbackDownloadDetail(s, e);
        popupDetail.Hide();
    }


    function BeginCallbackDownloadDetail(s, e) {
          $.ajax(
            {
                type: "POST",
                url: "@Url.Content("~/D31405/exportDetailToExcel")",
                data:
                {
                    INVOICE_NO: INV_NO.GetText(),
                    delivery_no     : gridPopupDetail_DXFREditorcol0.GetText(),
                    route_cd        : gridPopupDetail_DXFREditorcol2.GetText(),
                    route_name      : gridPopupDetail_DXFREditorcol3.GetText(),
                    doc_dt          : convertDate2 (gridPopupDetail_DXFREditorcol4.GetValue()),
                    comp_price      : gridPopupDetail_DXFREditorcol5.GetText(),
                    qty             : gridPopupDetail_DXFREditorcol6.GetText(),
                    price           : gridPopupDetail_DXFREditorcol7.GetText(),
                    currency        : gridPopupDetail_DXFREditorcol8.GetText(),
                    amount          : gridPopupDetail_DXFREditorcol9.GetText(),
                    
              },
                success: function (result) {
                    
                    if (result.excelLink == 'Data not found!'){
                        //MessageBox(result.excelLink,'info_icon.png','Information',200);
                        
                        $.msgBox({ title: "info",type: "info", content: result.excelLink , afterClose : enabledButton });
                        
                        disabledButton();
                        
                    }else
                    {
                        var link = "@Url.Content("~/")"+result.excelLink;
                        window.location = link;
                    }

                    
                },
                error: function (result) {
                    //MessageBox('Error when downloading data.','error_icon.png','Error',280);
                    $.msgBox({ title: "error",type: "error", content: "Error when downloading data.", afterClose : enabledButton });
                    disabledButton();
                }
            });
    }
    //---------------------------------------------------------------------------------------------------------

    function checkDownloadData(){
        if (ValidationSearch()) {
            $.ajax({
            type: "POST",
            url: "@Url.Content("~/D31405/checkDownloadData")",
            data: {
                    LP_CD           : LogisticPartnerOption.GetValue(),
                    CREATED_DT_FROM : CREATED_DT_FROM.GetText(),
                    CREATED_DT_TO   : CREATED_DT_TO.GetText(),
                    INVOICE_DT_FROM : INVOICE_DT_FROM.GetText(),
                    INVOICE_DT_TO   : INVOICE_DT_TO.GetText(),
                    PAYMENT_DT_FROM : PAYMENT_DT_FROM.GetText(),
                    PAYMENT_DT_TO   : PAYMENT_DT_TO.GetText(),
                    StatusOption    : StatusOption.GetText(),
                    DELIVERY_NO     : DELIVERY_NO2.GetText(),
                    INVOICE_NO      : INVOICE_NO.GetText(),

                    inv_no          : GridDeliveryInvoiceAndPay_DXFREditorcol1.GetText(),
                    inv_dt          : convertDate (GridDeliveryInvoiceAndPay_DXFREditorcol2.GetValue()),
                    curr            : GridDeliveryInvoiceAndPay_DXFREditorcol3.GetText(),
                    total_amt       : GridDeliveryInvoiceAndPay_DXFREditorcol4.GetText(),
                    amt_before      : GridDeliveryInvoiceAndPay_DXFREditorcol5.GetText(),
                    tax_amt         : GridDeliveryInvoiceAndPay_DXFREditorcol6.GetText(),
                    status          : GridDeliveryInvoiceAndPay_DXFREditorcol7.GetText(),
                    plan            : convertDate2 (GridDeliveryInvoiceAndPay_DXFREditorcol9.GetValue()),
                    actual          : convertDate2 (GridDeliveryInvoiceAndPay_DXFREditorcol10.GetValue()),
                    progress        : GridDeliveryInvoiceAndPay_DXFREditorcol11.GetText(),
                    createdby       : GridDeliveryInvoiceAndPay_DXFREditorcol13.GetText(),
                    createddt       : convertDate2 (GridDeliveryInvoiceAndPay_DXFREditorcol14.GetValue()),
                },
                success: function (result) {

                        var resValue = result.split('|');
                        if (resValue[1] > 0 )
                        {
                            btnDownload_click();
                        }else{

                            $.msgBox({ title: "Warning", type: "alert", content: 'Data not found', afterClose : enabledButton });
                            disabledButton();
                        }
                        
                },
                error: function (result) {
                    $.msgBox({ title: "Warning", type: "alert", content: 'Error', afterClose : enabledButton });
                    disabledButton();
                }
            });
        }
    }

    function btnDownload_click(s,e) {

        //if (ValidationSearch()) {

            $.fileDownload("D31405/DownloadData", {
                data: {
                    LP_CD           : LogisticPartnerOption.GetValue(),
                    CREATED_DT_FROM : CREATED_DT_FROM.GetText(),
                    CREATED_DT_TO   : CREATED_DT_TO.GetText(),
                    INVOICE_DT_FROM : INVOICE_DT_FROM.GetText(),
                    INVOICE_DT_TO   : INVOICE_DT_TO.GetText(),
                    PAYMENT_DT_FROM : PAYMENT_DT_FROM.GetText(),
                    PAYMENT_DT_TO   : PAYMENT_DT_TO.GetText(),
                    StatusOption    : StatusOption.GetText(),
                    DELIVERY_NO     : DELIVERY_NO2.GetText(),
                    INVOICE_NO      : INVOICE_NO.GetText(),

                    inv_no          : GridDeliveryInvoiceAndPay_DXFREditorcol1.GetText(),
                    inv_dt          : convertDate2 (GridDeliveryInvoiceAndPay_DXFREditorcol2.GetValue()),
                    curr            : GridDeliveryInvoiceAndPay_DXFREditorcol3.GetText(),
                    total_amt       : GridDeliveryInvoiceAndPay_DXFREditorcol4.GetText(),
                    amt_before      : GridDeliveryInvoiceAndPay_DXFREditorcol5.GetText(),
                    tax_amt         : GridDeliveryInvoiceAndPay_DXFREditorcol6.GetText(),
                    status          : GridDeliveryInvoiceAndPay_DXFREditorcol7.GetText(),
                    //lp_cd2          : GridDeliveryInvoiceAndPay_DXFREditorcol9.GetText(),
                    //lp_name         : GridDeliveryInvoiceAndPay_DXFREditorcol10.GetText(),
                    plan            : convertDate2 (GridDeliveryInvoiceAndPay_DXFREditorcol12.GetValue()),
                    actual          : convertDate2 (GridDeliveryInvoiceAndPay_DXFREditorcol13.GetValue()),
                    progress        : GridDeliveryInvoiceAndPay_DXFREditorcol14.GetText(),
                    createdby       : GridDeliveryInvoiceAndPay_DXFREditorcol16.GetText(),
                    createddt       : convertDate2 (GridDeliveryInvoiceAndPay_DXFREditorcol17.GetValue())
                },
                successCallback: function (url) {
                    
                },
                failCallback: function (responseHtml, url) {
                    //MessageBox(responseHtml, 'warning_icon.png', 'Warning', 290);
                    $.msgBox({ title: "Warning", type: "alert", content: responseHtml, afterClose : enabledButton });
                    disabledButton();
                    
                }
            });
        //}
    }

    function btnDownloadDetail_click(s, e) {
        
//        $.fileDownload("D31405/DownloadDetailData", {
//            data: {
//                INVOICE_NO: INV_NO.GetText()
//            },
//            successCallback: function (url) {
//            },
//            failCallback: function (responseHtml, url) {
//                //MessageBox(responseHtml, 'warning_icon.png', 'Warning', 290);
//                $.msgBox({ title: "Warning", type: "alert", content: responseHtml, afterClose : enabledButton });
//                disabledButton();
//            }
//        });

    }


    function btnPrint_click(s, e) {
        isExecute = true;
        action = "printCertificate";
        GridDeliveryInvoiceAndPay.PerformCallback();
    }

    function checkStatus(parameterList){        
        $.ajax({
        type: "POST",
        url: "@Url.Content("~/D31405/checkStatus")",
        data: {
                //Grid : valGrid     
                Grid : parameterList
            },
            success: function (result) {
                var resValue = result.split('|');
                if (resValue[1] == 'true' )
                {
                    printcertificate(parameterList);
                }
                else{
                    $.msgBox({ title: "Warning", type: "alert", content: "Please select records with Status : Created!", afterClose : enabledButton });
                }
            },
            error: function (result) {
                $.msgBox({ title: "Warning", type: "alert", content: 'Error', afterClose : enabledButton });
                //disabledButton();
            }
        });
    }

    function printcertificate(parameterList){

            $.fileDownload("D31405/PrintCertificate/", {
                data: {
                    //Grid: valGrid
                    Grid : parameterList
                },
                successCallback: function (url) {
                },
                failCallback: function (responseHtml, url) {
                    alert(responseHtml);
                }
            });

    }

    function btnCancel_Click(s, e) {
        isExecute = true;
        action = "cancel";
        GridDeliveryInvoiceAndPay.PerformCallback();
    }

    function performCancel (parameterList){
        $.ajax({
        type: "POST",
        url: "@Url.Content("~/D31405/performCancel")",
        data: {
                //invoice_no: valGrid
                invoice_no : parameterList
            },
            success: function (result) {
                var resValue = result.split('|');
                if (resValue[0] == 'Error')
                {
                    //MessageBox(resValue[1],'error_icon.png','Error',280);
                    $.msgBox({ title: "Warning", content: resValue[1], afterClose : enabledButton });
                    //clearGrid();
                    disabledButton();
                    GridDeliveryInvoiceAndPay.ClearFilter();
                    GridDeliveryInvoiceAndPay.UnselectRows();
                }
                else
                {
                    //MessageBox(resValue[1],'info_icon.png','Information',330);
                    $.msgBox({ title: "info", type: "info", content: resValue[1], afterClose : enabledButton });
                    //clearGrid();
                    disabledButton();
                    GridDeliveryInvoiceAndPay.ClearFilter();
                    GridDeliveryInvoiceAndPay.UnselectRows();
                }
            },
            error: function (result) {
                disabledButton();
                //MessageBox(resValue[1],'error_icon.png','Error',300);
                $.msgBox({ title: "error", type: "error", content: resValue[1], afterClose : enabledButton });
                //clearGrid();
                GridDeliveryInvoiceAndPay.ClearFilter();
                GridDeliveryInvoiceAndPay.UnselectRows();
            }
        });

    }


    var MESSAGE;

    function checkProgressPosting(){

        console.log("MESSAGE : "+MESSAGE);

        if(MESSAGE == 'Posting Process Finished' || MESSAGE == 'Posting Failed, Invoice Status is Posted' || MESSAGE == 'Posting Failed, Invoice Status is Created' || MESSAGE == 'Posting Failed, Invoice Status is Paid' || MESSAGE == 'Error Posting' )
        {
            MESSAGE = "";
        }
        else
        {
            $.ajax({
                type: "POST",
                url: "@Url.Content("~/D31405/checkProgressPosting")",
                data: {},
                    success: function (result) {
                        //
                        var resValue = result.split('|');
                        console.log('RES : '+resValue[1]);
                        if (resValue[0] == 'Success'){

                            if (resValue[1] == 'Posting Failed, Invoice Status is Posted' || resValue[1] == 'Posting Failed, Invoice Status is Created' || resValue[1] == 'Posting Failed, Invoice Status is Paid' || resValue[1] == 'Error Posting' ){
                                $.msgBox({ title: "Warning", content: resValue[1], afterClose : enabledButton });
                                $('#progress').html('Posting Process Finished');
                                $('#info').delay(6000).hide("slow");
                                SearchData();
                                MESSAGE = resValue[1];

                            }
                            else if (resValue[1] == 'Posting Process Finished'){
                                $.msgBox({ title: "info", type:"info", content: resValue[1], afterClose : enabledButton });
                                SearchData();
                                $('#progress').html('Posting Process Finished');
                                $('#info').delay(6000).hide("slow");
                                MESSAGE = resValue[1];
                            }
                            else{
                                $('#info').show();
                                $('#progress').html('Verifying. Please wait...');
                                MESSAGE = resValue[1];
                            }
                        }else{
                            $('#info').hide();
                            MESSAGE = resValue[1];
                        }
                    },
                    error: function (result) {
                        $('#info').hide();
                        MESSAGE = resValue[1];
                    }
            });
            setTimeout("checkProgressPosting()",1000);
        }
    }

    function btnPosting_Click(s, e) {

        isExecute = true;
        action = "posting";
        GridDeliveryInvoiceAndPay.PerformCallback();
    }


    

    function btnReverse_Click(s,e) {

        isExecute = true;
        action = "reverse";
        GridDeliveryInvoiceAndPay.PerformCallback();

    }

    function performReverse(parameterList){
        
        $.ajax({
            type: "POST",
            url: "@Url.Content("~/D31405/performReverse")",
            data: {
                    //invoice_no: valGrid
                    invoice_no : parameterList
                },
                success: function (result) {
                    var resValue = result.split('|');
                    if (resValue[0] == 'Error')
                    {
                        disabledButton();
                        //MessageBox(resValue[1],'error_icon.png','Error',280);
                        $.msgBox({ title: "warning",  content: resValue[1] , afterClose : enabledButton });
                        //clearGrid();
                        GridDeliveryInvoiceAndPay.ClearFilter();
                        GridDeliveryInvoiceAndPay.UnselectRows();
                    }
                    else
                    {
                        disabledButton();
                        //MessageBox(resValue[1],'info_icon.png','Information',340);
                        $.msgBox({ title: "info", type: "info", content: resValue[1], afterClose : enabledButton });
                        //clearGrid();
                        GridDeliveryInvoiceAndPay.ClearFilter();
                        GridDeliveryInvoiceAndPay.UnselectRows();
                    }
                },
                error: function (result) {
                    disabledButton();
                    //MessageBox(resValue[1],'error_icon.png','Error',300);
                    $.msgBox({ title: "error", type: "error", content: resValue[1], afterClose : enabledButton });
                    //clearGrid();
                    GridDeliveryInvoiceAndPay.ClearFilter();
                    GridDeliveryInvoiceAndPay.UnselectRows();
                }
            });

    }

//    function openDetail(s, e) {

//        if (GridDeliveryInvoiceAndPay.GetSelectedRowCount() > 1) {
//            //MessageBox("You can only select one record.","warning_icon.png", "Warning", 270);
//            $.msgBox({ title: "Warning", type: "alert", content: "You can only select one record.", afterClose : enabledButton });
//            disabledButton();
//        }
//        else if (GridDeliveryInvoiceAndPay.GetSelectedRowCount() == 0) {
//            //MessageBox("Please select any record.", "warning_icon.png", "Warning", 235);
//            $.msgBox({ title: "Warning", type: "alert", content: "Please select any record.", afterClose : enabledButton });
//            disabledButton();
//        }
//        else 
//        {
//            //var j = JSON.stringify(GridDeliveryInvoiceAndPay.GetSelectedKeysOnPage());
//            //j = j.substring(2, j.length - 18);
//            var j = JSON.stringify(GridDeliveryInvoiceAndPay.GetSelectedKeysOnPage());
//            j = j.substring(2,j.length - 2)
//            j = j.split('|');
//            j = j[0];
//            //j[1];
//            //j[2];

//            InvoiceNo = j;
//            INV_NO.SetText(j);
//            //console.log(j);
//            gridPopupDetail.PerformCallback();
//            popupDetail.SetHeaderText("Invoice No : "+j);
//            popupDetail.Show();
//        }
//    }
    
    var toggle = 1;
    function openDetail(s, e) {
        GridDeliveryInvoiceAndPay.PerformCallback('ToggleColumns=SUBMIT;POSTING;PAY_DOC_NO;TRUCKING');

        if (toggle == 1){
            
            $('#grid').attr("style", "width:100%");
            btnToggle.SetText('Hide Detail');
            toggle = 0;
        }else{
            $('#grid').attr("style", "width:1242px");
            btnToggle.SetText('Show Detail');
            toggle = 1;
        }
    }

    function OnInvoiceNoClick(j) {
        InvoiceNo = j;
        INV_NO.SetText(j);
        gridPopupDetail.PerformCallback();
        popupDetail.SetHeaderText("Invoice No : "+j);
        popupDetail.Show();
        
    }

    function OnBeginCallbackGridDetail(s, e) {
        e.customArgs["InvoiceNo"] = InvoiceNo;
        //InvoiceNo = "";
    }

    function ValidationSearch() {
        var validate = true;
        if (CREATED_DT_FROM.GetText() == '') {
            //MessageBox('Please fill Created Date From!', 'warning_icon.png', 'Warning', 270);
            $.msgBox({ title: "Warning", type: "alert", content: "Please fill Created Date From!", afterClose : enabledButton });
            disabledButton();
            validate = false;
        }
        else if (CREATED_DT_TO.GetText() == '') {
            //MessageBox('Please fill Created Date To!', 'warning_icon.png', 'Warning', 270);
            $.msgBox({ title: "Warning", type: "alert", content: "Please fill Created Date To!", afterClose : enabledButton });
            disabledButton();
            validate = false;
        }
        else if (INVOICE_DT_FROM.GetText() == '') {
            //MessageBox('Please fill Invoice Date From!', 'warning_icon.png', 'Warning', 270);
            $.msgBox({ title: "Warning", type: "alert", content: "Please fill Invoice Date From!", afterClose : enabledButton });
            disabledButton();
            validate = false;
        }
        else if (INVOICE_DT_TO.GetText() == '') {
            //MessageBox('Please fill Invoice Date From!', 'warning_icon.png', 'Warning', 270);
            disabledButton();
            $.msgBox({ title: "Warning", type: "alert", content: "Please fill Invoice Date To!", afterClose : enabledButton });
            validate = false;
        }

        return validate;
    }

    function enabledButton() {
        btnDownload.SetEnabled(true);
        btnPrint.SetEnabled(true);
        btnCancel.SetEnabled(true);
        btnToggle.SetEnabled(true);
        btnPostInvoice.SetEnabled(true);
        btnReverse.SetEnabled(true);
        PRClearButton.SetEnabled(true);
        PRSearchButton.SetEnabled(true);
    }

    function disabledButton() {
        btnDownload.SetEnabled(false);
        btnPrint.SetEnabled(false);
        btnCancel.SetEnabled(false);
        btnToggle.SetEnabled(false);
        btnPostInvoice.SetEnabled(false);
        btnReverse.SetEnabled(false);
        PRClearButton.SetEnabled(false);
        PRSearchButton.SetEnabled(false);
    }

    function clearGrid() {
        CREATED_DT_FROM.SetText('');
        CREATED_DT_TO.SetText('');
        INVOICE_DT_FROM.SetText('');
        INVOICE_DT_TO.SetText('');
        PAYMENT_DT_FROM.SetText('');
        PAYMENT_DT_TO.SetText('');

        if (GridLogisticPartnerOption.GetVisibleRowsOnPage() != 1 ){
            LogisticPartnerOption.SetText('');
        }

        StatusOption.SetText('');
        DELIVERY_NO2.SetText('');
        INVOICE_NO.SetText('');


        GridDeliveryInvoiceAndPay.UnselectRows();
        GridStatusOption.UnselectAllRowsOnPage();
        GridLogisticPartnerOption.UnselectAllRowsOnPage();
        //clearSelection();
        GridDeliveryInvoiceAndPay.ClearFilter();
    }
</script>

<div style="display: table; border: 1px solid #002D96; background-color: #DEECFD;
    padding: 10px; width:1215px; margin-right: 10px;">
    @Html.Action("PartialHeader", "D31405")
</div>


<div style="height: 10px;">

</div>


@* div spacing *@ @* style="width:1340px"*@

<div id="grid" style="width: 1242px;">
    @Html.Action("PartialListData", "D31405")
</div>

@Html.DevExpress().TextBox(
    label =>
    {
        label.Name = "txtGridTemp";
        label.ClientVisible = false;
    }).GetHtml()

@Html.DevExpress().PopupControl(settings =>
{
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Name = "popupVerificationInvoice";
    settings.HeaderText = "Invoice verification header screen";
    settings.Modal = true;
    settings.ShowCloseButton = false;
    settings.CloseAction = CloseAction.CloseButton;
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(520);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(250);
    settings.SetContent(() =>
    {
        Html.RenderPartial("PopupVerification", null);
    });
}).GetHtml()

@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "popupDetail";
    settings.HeaderText = " Invoice No :";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(900);
    //settings.Height = System.Web.UI.WebControls.Unit.Pixel(470);
    //settings.MaxHeight = System.Web.UI.WebControls.Unit.Pixel(470);
    //settings.MinHeight = System.Web.UI.WebControls.Unit.Pixel(300);
    //settings.ScrollBars = ScrollBars.Vertical;
    //settings.Width = System.Web.UI.WebControls.Unit.Percentage(40);
    //settings.Height = System.Web.UI.WebControls.Unit.Percentage(100);
    settings.Modal = true;
    settings.ShowCloseButton = false;
    //settings.Top = 35;
    settings.CloseAction = CloseAction.CloseButton;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    //settings.DragElement = DragElement.Window;
    //settings.ShowHeader = false;
    settings.SetContent(() =>
    {
        Html.RenderPartial("popupDetailLayout");
    });
}).GetHtml()

@*MESSAGE BOX*@
@Html.Action("MessageBox", "D31405")